<template>
  <v-text-field
    v-if="!mailDomainOptions.length > 0"
    v-model="mailAddress"
    :disabled="props.disabled"
    :label="props.label"
    :hint="props.hint"
    prepend-inner-icon="mdi-email"
    :rules="[
      v => (!props.required || (v && v.length > 0)) || 'E-mail is required',
      () => (!props.required || isValidMailAddress()) || 'E-mail must be valid',
    ]"
    persistent-hint
    type="string"
  >
  </v-text-field>
  <div class="row mx-2" v-else>
    <div class="col col-6 px-0">
      <v-text-field
        v-model="mailAlias"
        :disabled="props.disabled"
        label="Email (Alias)"
        prepend-inner-icon="mdi-email"
        :rules="[
          v => (!props.required  || ( v && v.length > 0)) || 'Alias is required',
          () => (!props.required || isValidMailAddress()) || 'Alias is not valid',
        ]"
        persistent-hint
        type="string"
      >
      </v-text-field>
    </div>
    <div class="col col-6 px-0">
      <v-select
        :items="mailDomainOptions"
        v-model="selectedMailDomain"
        :disabled="props.disabled"
        label="Mail-Domain"
        prepend-inner-icon="mdi-at"
        :rules="[
          v => (!props.required || selectedMailDomainValid(v)) || 'Selecting a mail domain is required.',
        ]"
      ></v-select>
    </div>
    <div class="col col-12 mt-0 pt-0 px-0" v-if="selectedMailDomain != undefined && !selectedMailDomainValid(selectedMailDomain)">
      <v-alert
        type="error"
        elevation="1"
        >
        The currently used mail domain "{{ selectedMailDomain }}" does not match with the selected organisation.
        Please add the mail domain to the organisation settings or select another one.
      </v-alert>
    </div>
  </div>
</template>

<style scoped lang="scss">

</style>

<script setup lang="ts">
import {computed, onMounted, ref, watch} from "vue";

interface Props {
  fieldName?: string;
  label?: string;
  hint?: string;
  disabled?: boolean;
  email?: string;
  mailDomains?: object;
  required?: boolean;
}

const props = defineProps<Props>();
const emit = defineEmits(["dynamic-email-object"]);

const mailAddress = ref(props.email);
const mailAlias = ref();
const selectedMailDomain = ref();
const mailDomainOptions = computed({
  get: () => {
    const mailDomains = [];

    if (props.mailDomains !== undefined && Object.keys(props.mailDomains).length !== 0) {
      for (const [key, value] of Object.entries(props.mailDomains)) {
        value.forEach(domain => mailDomains.push(domain));
      }
    }
    return mailDomains;
  }
});

onMounted(() => {
  if (props.email?.length) {
    mailAlias.value = props.email.substring(0, props.email.indexOf('@'));
    selectedMailDomain.value = props.email.substring(props.email.indexOf('@') +1, props.email.length);
    mailAddress.value = props.email;
  }
});

watch(() => mailAddress.value, (emailInputValue) => {
  emit("dynamic-email-object", {
    fieldName: props.fieldName,
    fieldValue: mailAddress.value,
    valid: isValidMailAddress(mailAddress.value),
    changed: props.email !== mailAddress.value,
  });
});

watch(() => mailAlias.value, (mailAliasInputValue) => {
  mailAddress.value = mailAliasInputValue + '@' + selectedMailDomain.value;
});

watch(() => selectedMailDomain.value, (mailDomainInputValue) => {
  mailAddress.value = mailAlias.value + '@' + mailDomainInputValue;
});

const isValidMailAddress = () => {
  return /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(mailAddress.value);
}

const selectedMailDomainValid = (mailDomain) => {
  return mailDomainOptions.value.includes(mailDomain);
}

</script>